globals[
  file_x file_y file_z

  x_data y_data
  y_sand

  x_data_min x_data_max

  q_min q_max nq dq
  q_venstre_i n_i
  q_min_stolpe q_max_stolpe nq_stolpe dq_stolpe
  q_venstre_i_stolpe n_i_stolpe
  q_venstre q_højre

  fordeling
  fordeling_str
  action
  i_iteration

  fordeling_old
  fordeling_str_old
  a_sand_old
  b_sand_old
  sigma_y_data_old
  n_data_old
  df_res_old

  a_data b_data sigma_a sigma_b sigma_y sigma_r

  n_tpdf_min
  n_tpdf_max
  x_tpdf
  y_tpdf
  x_normpdf
  y_normpdf
  x_pdf
  y_pdf
  t_df

  hjælpefiler
]

to setup
  set x_data_min  -3.0
  set x_data_max   6.0
  let dx_data_max  0.0

  set q_min -500.0
  set q_max  500.0
  set nq     10000
  set dq    (q_max - q_min) / nq

  set q_min_stolpe -15.0
  set q_max_stolpe  15.0
  set nq_stolpe 99
  set dq_stolpe (q_max_stolpe - q_min_stolpe) / nq_stolpe

  set n_tpdf_min  1
  set n_tpdf_max 10

  set hjælpefiler "fordeling_a_b_y_hjælpefiler"

  let file (word "./" hjælpefiler "/t_95_df.txt")
  læs_data file
  set t_df (sentence [-1] file_y)

  set x_data []
  set y_data []
  set y_sand []

  foreach (n-values n_data_old [i -> i]) [i ->
    let xx x_data_min + (x_data_max - x_data_min) / (n_data_old - 1) * i
    let dxx 0.0
    if (i > 0 and i < n_data_old - 1) [set dxx dx_data_max * ((random-float 2) - 1)]
    set x_data lput (xx + dxx) x_data
    set y_sand lput (a_sand * (xx + dxx) + b_sand) y_sand
  ]

  set q_venstre_i []
  foreach (n-values nq [i -> i]) [i ->
    set q_venstre_i lput (q_min + dq * i) q_venstre_i
  ]
  set n_i (n-values nq [0.0])

  set q_venstre_i_stolpe []
  foreach (n-values nq_stolpe [i -> i]) [i ->
    set q_venstre_i_stolpe lput (q_min_stolpe + dq_stolpe * i) q_venstre_i_stolpe
  ]
  set n_i_stolpe (n-values nq_stolpe [0.0])

  læs_tpdf df_res_old
  læs_normpdf
end

to go
  if (fordeling != 1 and fordeling != 2 and fordeling != 3 and fordeling != 4) [
    set fordeling 1
    set fordeling_str "t_a"
  ]
  if (action != 1) [
    show "start"
    set fordeling_old fordeling
    set fordeling_str_old fordeling_str
    set a_sand_old a_sand
    set b_sand_old b_sand
    set sigma_y_data_old sigma_y_data
    set n_data_old n_data
    set df_res_old df_res
    setup
    set i_iteration 1
    set action 1
  ]

  iteration

  if (fordeling_old != fordeling) [set action 0]
  if (a_sand_old != a_sand) [set action 0]
  if (b_sand_old != b_sand) [set action 0]
  if (sigma_y_data_old != sigma_y_data) [set action 0]
  if (n_data_old != n_data) [set action 0]
  if (df_res_old != df_res) [set action 0]
end

to iteration
  set y_data []
  foreach (n-values n_data_old [j -> j]) [j ->
    let yy_data (item j y_sand)
    let dy_data random-normal 0.0 sigma_y_data
    set y_data lput (yy_data + dy_data) y_data
  ]

  linear_regression

  let q 0.0
  if (fordeling_old = 1) [set q (a_data - a_sand) / sigma_a]
  if (fordeling_old = 2) [set q (b_data - b_sand) / sigma_b]
  if (fordeling_old = 3) [set q ((item 0 y_data) - (item 0 y_sand)) / sigma_y_data]
  if (fordeling_old = 4) [set q ((item 0 y_data) - (item 0 y_sand)) / sigma_y]

  let i (i_from_q q)
  if (i >= 0) [
    let n ((item i n_i) + 1)
    set n_i (replace-item i n_i n)

    let f (i_iteration / n_iteration_plot)
    if (f = int(f)) [
      foreach (n-values nq_stolpe [k -> k]) [k ->
        let q1_stolpe (q_min_stolpe + k * dq_stolpe)
        let q2_stolpe (q1_stolpe + dq_stolpe)
        let i1 (i_from_q q1_stolpe)
        let i2 (i_from_q q2_stolpe)
        set n_i_stolpe (replace-item k n_i_stolpe sum(sublist n_i i1 (i2 + 1)))
      ]
      let n_i_stolpe_max (max n_i_stolpe)

      setup_plot1 q_min_stolpe q_max_stolpe 0.0 n_i_stolpe_max nq_stolpe
      stolpe_diagram q_venstre_i_stolpe n_i_stolpe "plot1" "pen1" black

      pdf_spejling_skalering x_tpdf y_tpdf (n_i_stolpe_max / (item 0 y_tpdf))
      graf x_pdf y_pdf "plot1" "pen2" red
      pdf_spejling_skalering x_normpdf y_normpdf (n_i_stolpe_max / (item 0 y_normpdf))
      graf x_pdf y_pdf "plot1" "pen2" blue

      let n_cut (0.025 * sum(n_i))
      let l 0
      while [sum(sublist n_i 0 (l + 1)) < n_cut] [set l (l + 1)]
      set q_venstre (item l q_venstre_i)
      set l (nq - 1)
      while [sum(sublist n_i l nq) < n_cut] [set l (l - 1)]
      set q_højre (item l q_venstre_i)

      graf (list q_venstre q_venstre) (list 0.0 n_i_stolpe_max) "plot1" "pen2" green
      graf (list q_højre q_højre) (list 0.0 n_i_stolpe_max) "plot1" "pen2" green

      setup_plot2 x_data_min x_data_max 0.1 ((min y_sand) - 2 * sigma_y_data) ((max y_sand) + 2 * sigma_y_data) 0.1
      punkt x_data y_data "plot2" "pen1" red
      let x1 (x_data_min - (x_data_max - x_data_min))
      let x2 (x_data_max + (x_data_max - x_data_min))
      graf (list x1 x2) (list (a_sand * x1 + b_sand) (a_sand * x2 + b_sand)) "plot2" "pen1" black
      graf (list x1 x2) (list (a_data * x1 + b_data) (a_data * x2 + b_data)) "plot2" "pen1" red

      let str1 (str_tal_n_decimaler a_sand_old 1)
      let str2 (str_tal_n_decimaler b_sand_old 1)
      let str3 (str_tal_n_decimaler sigma_y_data_old 1)
      show (word "i_iteration=" i_iteration "  fordeling=" fordeling_str_old "  a_sand=" str1 "  b_sand=" str2 "  sigma_y_data=" str3 "  n_data=" n_data_old "  df_res=" df_res_old)
    ]
  ]

  set i_iteration (i_iteration + 1)
end

to-report i_from_q [q]
  if (q < q_min or q > q_max) [report -1]
  report int ((q - q_min) / dq)
end

to-report i_from_q_stolpe [q]
  if (q < q_min_stolpe or q > q_max_stolpe) [report -1]
  report int ((q - q_min_stolpe) / dq_stolpe)
end

to linear_regression
  let xm (sum x_data) / n_data_old
  let ym (sum y_data) / n_data_old
  let x_minus_xm (map [x -> x - xm] x_data)
  let sum_y_gange_x_minus_xm (sum (map [[a b] -> a * b] y_data     x_minus_xm))
  let sum_square_x_minus_xm  (sum (map [[a b] -> a * b] x_minus_xm x_minus_xm))

  set a_data sum_y_gange_x_minus_xm / sum_square_x_minus_xm
  set b_data (ym - a_data * xm)

  let y_reg (map [x -> a_data * x + b_data] x_data)
  let sum_square_error (sum (map [[a b] -> (a - b) ^ 2] y_data y_reg))

  set sigma_r (sum_square_error / df_res_old) ^ 0.5

  set sigma_a sigma_r * (1 / sum_square_x_minus_xm) ^ 0.5
  set sigma_b sigma_r * (1 / n_data_old + xm ^ 2 / sum_square_x_minus_xm) ^ 0.5
  set sigma_y sigma_r
end

to setup_plot1 [xmin xmax ymin ymax n_stolpe]
  set-current-plot "plot1"
  clear-plot
  set-plot-x-range xmin xmax
  set-plot-y-range ymin ymax
  set-histogram-num-bars n_stolpe
end

to setup_plot2 [xmin xmax udvid_x ymin ymax udvid_y]
  set-current-plot "plot2"
  clear-plot
  let delta_x (xmax - xmin)
  let delta_y (ymax - ymin)
  let str1 str_tal_n_decimaler (xmin - delta_x * udvid_x) 2
  let str2 str_tal_n_decimaler (xmax + delta_x * udvid_x) 2
  let str3 str_tal_n_decimaler (ymin - delta_y * udvid_y) 2
  let str4 str_tal_n_decimaler (ymax + delta_y * udvid_y) 2
  let x1 read-from-string str1
  let x2 read-from-string str2
  let y1 read-from-string str3
  let y2 read-from-string str4
  set-plot-x-range x1 x2
  set-plot-y-range y1 y2
end

to stolpe_diagram [venstre_i værdi_i plotname penname pencolor]
  set-current-plot plotname
  set-current-plot-pen penname
  set-plot-pen-color pencolor
  foreach (n-values (length venstre_i) [i -> i]) [i ->
    plotxy (item i venstre_i) (item i værdi_i)
  ]
end

to graf [sted_i værdi_i plotname penname pencolor]
  set-current-plot plotname
  set-current-plot-pen penname
  set-plot-pen-color pencolor
  plot-pen-up
  plotxy (item 0 sted_i) (item 0 værdi_i)
  plot-pen-down
  foreach (n-values (length sted_i) [i -> i]) [i ->
    plotxy (item i sted_i) (item i værdi_i)
  ]
end

to-report report0
  report fordeling_str_old
end
to-report report1
  report (str_tal_n_decimaler q_venstre 5)
end
to-report report2
  report (str_tal_n_decimaler q_højre 5)
end
to-report report3
  let t (item (n_data_old - 2) t_df)
  report (str_tal_n_decimaler (- t) 5)
end
to-report report4
  let t (item (n_data_old - 2) t_df)
  report (str_tal_n_decimaler t 5)
end

to punkt [x_punkt y_punkt plotname penname pencolor]
  set-current-plot plotname
  set-current-plot-pen penname
  set-plot-pen-color pencolor
  let dx_vindue 10.0
  let dy_vindue  6.4
  let d_x (plot-x-max - plot-x-min) * 0.01
  let d_y (plot-y-max - plot-y-min) * 0.01 * (dx_vindue / dy_vindue)
  foreach (n-values length (x_punkt) [i -> i]) [i ->
    let x (item i x_punkt)
    let y (item i y_punkt)
    plot-pen-up
    plotxy (x - d_x) (y - d_y)
    plot-pen-down
    plotxy (x + d_x) (y - d_y)
    plotxy (x + d_x) (y + d_y)
    plotxy (x - d_x) (y + d_y)
    plotxy (x - d_x) (y - d_y)
  ]
end

to pdf_spejling_skalering [x y skalafaktor]
  set x_pdf x
  set x_pdf (remove-item 0 x_pdf)
  set x_pdf (reverse x_pdf)
  set x_pdf (map [v -> -1.0 * v] x_pdf)
  set x_pdf (sentence x_pdf x)

  set y_pdf (map [v -> skalafaktor * v] y)
  let yy y_pdf
  set yy (remove-item 0 yy)
  set yy (reverse yy)
  set y_pdf (sentence yy y_pdf)
end

to læs_tpdf [nr]
  let file (word nr)
  if (nr <= 9) [set file (word "0" nr)]
  set file (word "./" hjælpefiler "/tpdf" file ".txt")
  læs_data file
  set x_tpdf file_x
  set y_tpdf file_y
end

to læs_normpdf
  let file (word "./" hjælpefiler "/normpdf.txt")
  læs_data file
  set x_normpdf file_x
  set y_normpdf file_y
end

to læs_data [file]
  let separator " "
  let separators (list "\t")

  set file_x []
  set file_y []
  set file_z []

  file-open file

  while [not file-at-end?] [
    let line file-read-line
;    show line

    foreach separators [str ->
      while [is-number? (position str line)] [
        let i (position str line)
        foreach (n-values (length str) [j -> j]) [j ->
          set line (remove-item i line)
        ]
        set line (insert-item i line separator)
      ]
    ]
;    show line

    let line2 ""
    let space ""
    foreach (n-values (length line) [i -> i]) [i ->
      let c (item i line)
      ifelse (c = " ") [
        if (separator = " " and space != " " and line2 != "") [set space " "]
      ][
        set line2 (word line2 space c)
        set space ""
      ]
    ]
    if (last line2 != separator) [set line2 (word line2 separator)]
    set line line2
;    show line

    let file_xx "-"
    let file_yy "-"
    let file_zz "-"
    let file_nr 0
    let file_xyz ""
    foreach (n-values (length line) [i -> i])  [i ->
      let c (item i line)
      ifelse (c = separator) [
        ifelse (file_xyz = "") [set file_xyz "-"][set file_xyz (read-from-string file_xyz)]
        if (file_nr = 0) [set file_xx file_xyz]
        if (file_nr = 1) [set file_yy file_xyz]
        if (file_nr = 2) [set file_zz file_xyz]
        set file_nr (file_nr + 1)
        set file_xyz ""
      ][
        set file_xyz (word file_xyz c)
      ]
    ]
    set file_x lput file_xx file_x
    set file_y lput file_yy file_y
    set file_z lput file_zz file_z
  ]

  file-close
end

to-report str_tal_n_decimaler [tal n]
  let fortegn (ifelse-value (tal >= 0) [""] ["-"])
  set tal (ifelse-value (tal >= 0) [tal] [ tal * -1])

  if (tal < 0.0000000001) [set tal 0]
  if (tal > 10000000000) [set tal 10000000000]
  let str (word tal)
  let i (position "E" str)
  if (i != false) [
    let len length str
    let a (substring str 0 i)
    let b (substring str (i + 1) len)
    set a (word "00000000000000000000" a "00000000000000000000")
    set i (position "." a)
    set a (remove-item i a)
    set i (i + (read-from-string b))
    set len length a
    set str (word (substring a 0 i) "." (substring a i len))
  ]

  set i (position "." str)
  if (i = false) [set str (word str ".")]
  set i (position "." str)
  set str (word str "00000000000000000000")
  let str_ (remove-item i str)
  let str2 (substring str_ 0 (i + n))
  let str3 (item (i + n) str_)

  let a read-from-string str2
  let b read-from-string str3
  if (b >= 5) [set a (a + 1)]
  let str22 (word a)

  if (str22 = "0") [
    let str22a "0"
    let str22b ""
    foreach (n-values n [j -> j]) [j ->
      set str22b (word str22b "0")
    ]
    report (word str22a "." str22b)
  ]

  let len (length str22)
  let str22a ""
  let str22b ""
  foreach (n-values max (list n len) [j -> j]) [j ->
    if (j <= len - 1) [
      let s (item (len - 1 - j) str22)
      if (j <= n - 1) [set str22b (word s str22b)]
      if (j >  n - 1) [set str22a (word s str22a)]
    ]
    if (j > len - 1) [set str22b (word "0" str22b)]
  ]
  if (str22a = "") [set str22a "0"]
  report (word fortegn str22a "." str22b)
end
@#$#@#$#@
GRAPHICS-WINDOW
262
10
699
448
-1
-1
13.0
1
10
1
1
1
0
1
1
1
-16
16
-16
16
0
0
1
ticks
30.0

BUTTON
16
65
212
98
go
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

PLOT
233
10
729
462
plot1
NIL
NIL
0.0
0.0
0.0
0.0
false
false
"" ""
PENS
"pen1" 1.0 1 -16777216 true "" ""
"pen2" 1.0 0 -2674135 true "" ""

SLIDER
13
392
185
425
n_iteration_plot
n_iteration_plot
1000
10000
1000.0
1000
1
NIL
HORIZONTAL

SLIDER
13
287
185
320
n_data
n_data
3
12
4.0
1
1
NIL
HORIZONTAL

SLIDER
13
327
185
360
df_res
df_res
n_tpdf_min
n_tpdf_max
2.0
1
1
NIL
HORIZONTAL

PLOT
763
78
1279
408
plot2
NIL
NIL
0.0
10.0
0.0
10.0
false
false
"" ""
PENS
"pen1" 1.0 0 -16777216 true "" "plot count turtles"

MONITOR
281
58
406
103
95% konfidens venstre
report1
17
1
11

MONITOR
600
59
712
104
95% konfidens højre
report2
17
1
11

MONITOR
281
111
387
156
teoretisk t_95
report3
17
1
11

MONITOR
600
112
706
157
teoretisk t_95
report4
17
1
11

BUTTON
16
105
111
138
setup_n_y
set fordeling 3\nset fordeling_str \"n_y\"\n
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
16
26
111
59
setup_t_a
set fordeling 1\nset fordeling_str \"t_a\"
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
119
26
211
59
setup_t_b
set fordeling 2\nset fordeling_str \"t_b\"\n
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
14
153
186
186
a_sand
a_sand
-2
2
1.2
0.1
1
NIL
HORIZONTAL

SLIDER
14
191
186
224
b_sand
b_sand
-2
2
-0.8
0.1
1
NIL
HORIZONTAL

SLIDER
14
228
186
261
sigma_y_data
sigma_y_data
0.1
10
5.0
0.1
1
NIL
HORIZONTAL

BUTTON
119
105
212
138
setup_t_y
set fordeling 4\nset fordeling_str \"t_y\"\n
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

MONITOR
283
192
345
237
fordeling
report0
17
1
11

@#$#@#$#@
## WHAT IS IT?

Simuleringer af t-fordelinger for hældningen a og skæringen med y-aksen b.

## HOW IT WORKS

I hver iteration produceres der et sæt af y-værdier der er normalfordelte omkring den sande linje. (a, b) beregnes og t-værdierne findes vha. estimaterne for spredningerne på a og b.

## HOW TO USE IT

Vælg den fordeling der skal simuleres og tryk på go-forever.

## THINGS TO NOTICE

De teoretisk fordelinger (røde t-fordelinger og blå normalfordelinger) hentes ind i NetLogo som beregnede data fra Nspire.

## THINGS TO TRY

Vha. skyderne
(i) modificér den sande linje og spredningen på y'erne.
(ii) modificér antal punkter og antal frihedsgrader.

## EXTENDING THE MODEL

## NETLOGO FEATURES

## RELATED MODELS

## CREDITS AND REFERENCES

Copyright 2019 Jon Rotvig

![CC BY-NC-SA 4.0](https://licensebuttons.net/l/by-nc-sa/4.0/88x31.png)

Dette værk er licenseret under en Creative Commons Kreditering-IkkeKommerciel–DelPåSammeVilkår 4.0 International Licens.  For en kopi af licensen, besøg https://creativecommons.org/licenses/by-nc-sa/4.0/deed.da
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270
@#$#@#$#@
NetLogo 6.0.3
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180
@#$#@#$#@
0
@#$#@#$#@
